<?php
/**
 * Created by PhpStorm.
 * User: Noa
 * Date: 24/09/2017
 * Time: 14:53
 */

namespace Cloud\RD\Calculator;


class Calculator
{

    /**
     * @param float $a first operand
     * @param float $b second operand
     * @param string $probe Debug parameter
     * @return int|string
     * @throws CalculatorException
     */
    public function add($a, $b, &$probe = '')
    {
        if (!is_numeric($a) || !is_numeric($b)) {

            throw new CalculatorException("Adding not real numbers");
        }

        if ($a > 0) {

            if ($b > 0) {

                $probe = '1 1';

            } elseif ($b == 0) {

                $probe = '1 0';

            } elseif ($b < 0) {

                $probe = '1 -1';

            }


        } elseif ($a == 0) {

            if ($b > 0) {

                $probe = '0 1';

            } elseif ($b == 0) {

                $probe = '0 0';

            } elseif ($b < 0) {

                $probe = '0 -1';

            }

        } elseif ($a < 0) {

            if ($b > 0) {

                $probe = '-1 1';

            } elseif ($b == 0) {

                $probe = '-1 0';

            } elseif ($b < 0) {

                $probe = '-1 -1';

            }

        }

        return $a + $b;
    }
}